<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: examplePrototypeCustomGoal.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('examplePrototypeCustomGoal_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">examplePrototypeCustomGoal.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example of how to prototype a custom goal in Matlab. See <a class="el" href="mocouserguide.html#mococustomgoal">Defining a custom goal or cost</a>.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: examplePrototypeCustomGoal.m                                 %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2019 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Christopher Dembia                                              %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">function value = examplePrototypeCustomGoal</div>
<div class="line">% This example allows Matlab users of Moco to prototype custom costs/goals</div>
<div class="line">% to send to <a class="code" href="namespaceOpenSim.html">OpenSim</a>/Moco developers for implementing in C++.</div>
<div class="line">% If you can write your goal in the &quot;...GoalIntegrand&quot; and &quot;...GoalValue&quot;</div>
<div class="line">% functions below and you can invoke evaluateCustomGoal() (shown below)</div>
<div class="line">% without error, then <a class="code" href="namespaceOpenSim.html">OpenSim</a>/Moco developers may be able to convert your goal</div>
<div class="line">% into a proper C++ goal. Once your prototype works, create an issue</div>
<div class="line">% on GitHub. We cannot guarantee that <a class="code" href="namespaceOpenSim.html">OpenSim</a>/Moco developers will have the</div>
<div class="line">% time to prioritize creating this goal in C++. See the C++ Moco example</div>
<div class="line">% exampleMocoCustomEffortGoal to see how you could create a C++ plugin for a</div>
<div class="line">% custom goal on your own.</div>
<div class="line">%</div>
<div class="line">% In C++, MocoGoals can be in cost mode or endpoint constraint mode. In this</div>
<div class="line">% example, we expect that your goal is in cost mode.</div>
<div class="line">%</div>
<div class="line">% In this example, the custom goal is minimizing the sum of squared controls</div>
<div class="line">% divided by the time duration of the phase.</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">study = MocoStudy();</div>
<div class="line">problem = study.updProblem();</div>
<div class="line">problem.setModel(ModelFactory.createPendulum());</div>
<div class="line">problem.setTimeBounds(0, 1);</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/jointset/j0/q0/value&#39;</span>, [], 0, 0.25 * pi);</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/jointset/j0/q0/speed&#39;</span>, [], 0, 0);</div>
<div class="line">problem.setControlInfo(<span class="stringliteral">&#39;/tau0&#39;</span>, [-2, 5]);</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">trajectory = solver.createGuess();</div>
<div class="line"> </div>
<div class="line">value = evaluateCustomGoal(problem, trajectory, ...</div>
<div class="line">        @calcMyCustomEffortGoalIntegrand, @calcMyCustomEffortGoalValue);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> integrand = calcMyCustomEffortGoalIntegrand(model, state)</div>
<div class="line">% Compute the integrand <span class="keywordflow">for</span> the integral portion of the cost goal.</div>
<div class="line"> </div>
<div class="line">model.realizeVelocity(state);</div>
<div class="line">% This returns all model controls as a SimTK::Vector.</div>
<div class="line">controls = model.getControls(state);</div>
<div class="line">% This computes the sum of squared element values (squared 2-norm).</div>
<div class="line">integrand = 0;</div>
<div class="line"><span class="keywordflow">for</span> i = 0:controls.size() - 1</div>
<div class="line">    integrand = integrand + controls.get(i)^2;</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> value = calcMyCustomEffortGoalValue(...</div>
<div class="line">                        model, initial_state, final_state, integral)</div>
<div class="line">% Compute the goal value from the phase<span class="stringliteral">&#39;s initial and final states, and from</span></div>
<div class="line"><span class="stringliteral">% the integral of the integrand function over the phase. The integration is</span></div>
<div class="line"><span class="stringliteral">% performed for you by evaluateCustomGoal().</span></div>
<div class="line"><span class="stringliteral">value = integral / (final_state.getTime() - initial_state.getTime());</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">function goalValue = evaluateCustomGoal(...</span></div>
<div class="line"><span class="stringliteral">                        problem, mocoTraj, integrandFunc, goalFunc)</span></div>
<div class="line"><span class="stringliteral">% Test a custom goal, defined by integrand and goal functions, on the</span></div>
<div class="line"><span class="stringliteral">% provided problem and MocoTrajectory.</span></div>
<div class="line"><span class="stringliteral">model = problem.getPhase(0).getModelProcessor().process();</span></div>
<div class="line"><span class="stringliteral">org.opensim.modeling.opensimMoco.prescribeControlsToModel(mocoTraj, model);</span></div>
<div class="line"><span class="stringliteral">statesTraj = mocoTraj.exportToStatesTrajectory(problem);</span></div>
<div class="line"><span class="stringliteral">model.initSystem();</span></div>
<div class="line"><span class="stringliteral">N = statesTraj.getSize();</span></div>
<div class="line"><span class="stringliteral">integrand = zeros(N, 1);</span></div>
<div class="line"><span class="stringliteral">for i = 0:(N - 1)</span></div>
<div class="line"><span class="stringliteral">    integrand(i + 1) = integrandFunc(model, statesTraj.get(i));</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">integral = trapz(integrand);</span></div>
<div class="line"><span class="stringliteral">goalValue = goalFunc(model, statesTraj.front(), statesTraj.back(), integral);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
